/* 
  filter.h - Header file for particle filtering subroutines 
*/


void doPF (controlPFstruct * const pControlPF, metastruct * const pMeta);
void doPFYear2 (controlPFstruct * const pControlPF, metastruct * const pMeta, 
                particlestruct * const pParticles);
void readPriorsFromFile(controlPFstruct * const pControlPF,
                particlestruct * const pParticles);
void doPFYear3Plus (controlPFstruct * const pControlPF, metastruct * const pMeta, 
                particlestruct * const pParticles);
void processResults (controlPFstruct * const pControlPF, metastruct * const pMeta, 
                particlestruct * const pParticles);
void filterParticles (Int intYear,
                       controlPFstruct * const pControlPF, 
                       metastruct * const pMeta, 
                       particlestruct * const pParticles);
void importanceSample (Int intYear,
                       controlPFstruct * const pControlPF, 
                       metastruct * const pMeta, 
                       particlestruct * const pParticles);
void auxiliaryParticleFilter (Int intYear,
                       controlPFstruct * const pControlPF, 
                       metastruct * const pMeta, 
                       particlestruct * const pParticles);
void bootstrapFilter (Int intYear,
                      controlPFstruct * const pControlPF,
                      metastruct * const pMeta,
                      particlestruct * const pParticles);
void packThetaStar(controlPFstruct * const pControlPF,
                   particlestruct * const pParticles,
                   double ** const dblThetaStar);
void sampleParticles(Int * const intResampleIndex, 
                     controlPFstruct * const pControlPF,
                     particlestruct * const pParticles);
void sampleParticles1(Int * const intResampleIndex, 
                     controlPFstruct * const pControlPF,
                     particlestruct * const pParticles,
                     double **dblMeanMat);
void kernelSmooth(double dblHSq, Int intNParticles, Int intNParams, 
  double **dblSigmaThetaStar,
  double **MeanMat, double **dblThetaStar);
void unpackThetaStar(controlPFstruct * const pControlPF,
                   particlestruct * const pParticles,
                   double ** const dblThetaStar);
void resample(Int * const intResampleIndex, 
              Int intNResamples, 
              const double * const dblWeights, 
              Int intNWeights,
              enum resamplingAlgorithm enumResamplingAlgorithm,
              long *plngSeed);
void randomResample(Int * const intResampleIndex, 
              Int intNResamples, 
              const double * const dblWeights, 
              Int intNWeights,
              long *plngSeed);
void residualResample(Int * const intResampleIndex, 
              Int intNResamples, 
              const double * const dblWeights, 
              Int intNWeights,
              long *plngSeed);
void sampleAndKSParticles(Int * const intResampleIndex, 
                          controlPFstruct * const pControlPF,
                          particlestruct * const pParticles);
double getC(particlestruct * const pParticles, Int intNParticles);
void rejectionControl(particlestruct * const pParticles, Int intNParticles, 
                     Int * const intIndex, Int * const pintNIndex,
                     double dblC);
void scaleParticleWeights (Int intYear,
                           controlPFstruct * const pControlPF, 
                           metastruct * const pMeta, 
                           particlestruct * const pParticles);


