/* 
  model.h - Header file for population dynamics model routines
*/

void initializeParamNumber(controlPFstruct * const pControlPF);
void initializeParams(controlPFstruct * const pControlPF, 
                                    particlestruct * const pParticles);
void initializeStates(controlPFstruct * const pControlPF, 
                                    particlestruct * const pParticles);
void initializeStatesAnzjs(controlPFstruct * const pControlPF, 
                      particlestruct * const pParticles);
void initializeStatesTakis(controlPFstruct * const pControlPF, 
                      particlestruct * const pParticles);
void getStableAgeStructure(double * const dblStableAgeStructure, 
                          double dblSa, double dblSj, double dblAlpha);
void initializeStatesFromSurvival(controlPFstruct * const pControlPF,
                      particlestruct * const pParticles);
void runPopulationProcess(Int intYear, boolean blnIsStochastic,
                          controlPFstruct * const pControlPF, particlestruct * const pParticles);
void runHarvestSubProcess (Int intYear, boolean blnIsStochastic,
                          controlPFstruct * const pControlPF,
                          particlestruct * const pParticles);
void runFixedHarvestSubProcess (Int intYear, boolean blnIsStochastic,
                          controlPFstruct * const pControlPF,
                          particlestruct * const pParticles);
void runPropHarvestSubProcess (Int intYear, boolean blnIsStochastic,
                          controlPFstruct * const pControlPF,
                          particlestruct * const pParticles);
void runFixedTotHarvestSubProcess (Int intYear, boolean blnIsStochastic,
                                controlPFstruct * const pControlPF,
                                particlestruct * const pParticles);
void runMovementSubProcess (Int intYear, boolean blnIsStochastic,
                          controlPFstruct * const pControlPF, 
                          particlestruct * const pParticles);
double getA(Int enumModel, Int intColony, double * const dblParams, Int intPups, Int intAge);
double getSj(Int enumModel, Int intYear, Int intColony, double * const dblParams, 
  Int intPups, Int intPupData, Int intTauPups);
double getSa(Int enumModel, Int intYear, Int intColony, double * const dblParams, 
  Int intPups, Int intPupData, Int intTauPups, Int intAge);
Int getInitialBreedersUnderDensDepFecundity(double dblA, double dblBeta, 
                                            double dblRho, double dblSa, 
                                            Int intPups, Int intSubAdults);
boolean checkAllMissingObservations (Int intYear,
                                  controlPFstruct * const pControlPF);
void getWeights (Int intYear, double * dblWeights, controlPFstruct * const pControlPF, 
                 metastruct * const pMeta, particlestruct * const pParticles);
void getIntegratedWeights (Int intYear, double * dblWeights, controlPFstruct * const pControlPF, 
                 metastruct * const pMeta, particlestruct * const pParticles);
void getNonIntegratedWeights (Int intYear, double * dblWeights, controlPFstruct * const pControlPF, 
                 metastruct * const pMeta, particlestruct * const pParticles);
void samplePsi (controlPFstruct * const pControlPF,
                particlestruct * const pParticles,
                Int intYear);

