/* 
  numeric.h - Header file for misc numeric routines
*/

//Numerical recipes
double dbeta(double z, double w);
double dbetacf(double a,double b,double x);
double dbetai(double a,double b,double x);
double drbinom(Int n, double pp, long *idum);
double dgammln(double xx);
double drnorm(double mean, double sd, long *idum);
double drpois(double xm, long *idum);
double dran1(long *idum);
float qgaus(float (*func)(float), float a, float b);
void choldc(double **a,Int n,double *p);
float brent(float ax, float bx, float cx, float (*f)(float, double *, int), float tol,
	float *xmin, double *otherparams, Int notherparams);

//KBN authored or modified versions thereof
double dgamdev(double alpha,double beta,long *seed);
double drbeta(double aa, double bb, long *seed);
double dround(double x);
Int iround(double x);
double dlnorm(double y,double mu,double sigma);
double dnorm(double y,double mu,double sigma);
double drunif(double a,double b,long *idum);
double drnbinom(double n,double p,long *seed);

double logdnorm(double y,double mu,double sigma);

double dmeanVector(const double * const y, Int start, Int end);
double dmeanVectorExcludeMissing(const double * const y, Int start, Int end, double missingValue);
double dsumVector(const double * const y, Int start, Int end);
void dstandardizeVectorToOut(const double * const y, Int start, Int end, 
  double * const out, double total);

boolean areElementsIdentical(const double * const y, Int start, Int end);

//More routines from Ken
void alias(Int numsims, Int sampsize, double *probs, Int *sample, long *seed);
void covMat(Int numpars, Int numsims, double a_wt, double **theta_star, 
   double *mean_theta_star, double **mean_mat,  double **sigma_theta_star);
void wt_covMat(Int numpars, Int numsims, double a_wt, double **theta_star,
   double *mean_theta_star, double **mean_mat, double **sigma_theta_star,
   double *wts);





