/* 
  util.h - Header file for utilities module util.c 
*/

void SkipLines (FILE *pFile, long NLines);
Int GetIntFromControlFile (FILE *pFile);
long GetLongFromControlFile (FILE *pFile);
boolean GetBooleanFromControlFile (FILE *pFile);
double GetDoubleFromControlFile (FILE *pFile);
void CopyStringFromControlFile (FILE *pFile, char * const strPutInto);

particlestruct * mallocParticleStruct (Int intNParticles, Int intNAges, 
  Int intNColonies, Int intNParams);
void freeParticleStruct (particlestruct *pParticles, Int intNParticles, 
                         Int intNAges, Int intNColonies, 
                         Int intNParams);

char *cdifftime (time_t finish, time_t start);

void writeParamsSummary(controlPFstruct * const pControlPF, 
                      particlestruct * const pParticles);
void writeStatesSummary(controlPFstruct * const pControlPF, 
                      particlestruct * const pParticles,
                      Int intYear, Int blnShowNewState);
void writeStateSummaryForOneAge(controlPFstruct * const pControlPF, 
                                particlestruct * const pParticles,
                                Int intYear, Int intAge, Int blnShowNewState);
void writeMeta(controlPFstruct * const pControlPF,
               metastruct * const pMeta,
               int blnWriteToDebugFile,
               int blnWriteToOutputFile);
void readMeta(controlPFstruct * const pControlPF,
               metastruct * const pMeta);
void writeDVectorSummary(controlPFstruct * const pControlPF, 
                         double * const dblVector, Int intStart, Int intEnd);
double getESS(controlPFstruct * const pControlPF, 
              particlestruct * const pParticles,
              Int *intIndex, Int intNIndex,
              Int blnWriteOut);
FILE *openParticleFile(char *strRootName, char *strPrefix, char *strSuffix,
                       Int intYear,
                       char *chrMode);
Int saveParticles(controlPFstruct * const pControlPF,
                  particlestruct * const pParticles,
                  Int *intIndex,
                  Int intNIndex,
                  Int intYear,
                  Int blnSaveAsBinary,
                  Int blnSaveNewState,
                  Int blnSaveParamsWeightsIDs,
                  Int blnSaveParentB,
                  Int blnSaveNParticles,
                  Int blnAppend,
                  Int blnCompact,
                  Int intMaxNToSave,
                  char *strSuffix);
Int loadParticlesBinary(particlestruct * const pParticles,
                  Int *intIndex,
                  Int intNIndex,
                  Int intYear,
                  Int intMaxNToLoad,
                  boolean blnLoadIDAndParent,
                  boolean blnLoadB,
                  char *strPrefix,
                  char *strSuffix);
Int getNParticlesBinary(Int intYear,
                  char *strPrefix,
                  char *strSuffix);
Int loadWeightsBinary(double *dblWeights,
                  Int *intIndex,
                  Int intNIndex,
                  Int intYear,
                  Int intMaxNToLoad,
                  char *strPrefix,
                  char *strSuffix);
void removeParticleFiles(controlPFstruct * const pControlPF, char *strSuffix);
FILE *openParticleFile(char *strRootName, char *strPrefix, char *strSuffix,
                       Int intYear, 
                       char *chrMode);
void writeCovMat(controlPFstruct * const pControlPF,
  particlestruct * const pParticles,
  double a_wt, double **theta_star, 
  double *mean_theta_star, double **mean_mat,  double **sigma_theta_star);

