#Compare.r - code to read in two lots of states estiamtes and plot them over each other

plot.target<-"bitmap"
filename<-"adults"
indep.est<-81530
indep.cl<-c(69650,96690)
indep.est.yr<-2008
plot.indep.est<-T
end.year<-2013

lwd<-2

ylab="Adults"
load("..//WithoutIndependentEst//StatesAdultsOldWeights.RData")
data1<-state.estimates
load("..//WithIndependentEst//StatesAdultsNewWeights.RData")
data2<-state.estimates

#tmp.par<-par(no.readonly=T)

extract.tot<-function(x){
  res<-list()
  res$mean.est<-apply(x$mean.est,1,sum)
  res$ucl.est<-apply(x$ucl.est,1,sum)
  res$lcl.est<-apply(x$lcl.est,1,sum)
  return(res)
}
data1.tot<-extract.tot(data1)
data2.tot<-extract.tot(data2)

start.year<-1984
years<-seq(start.year,start.year+dim(data1$mean.est)[1]-1)
if(!is.null(end.year)){
  ind<-1:which.max(years==end.year)
} else {
  ind<-1:length(years)
}
ylim<-c(0,200000) #c(min(c(data1.tot$lcl.est,data2.tot$lcl.est)),max(c(data1.tot$ucl.est,data2.tot$ucl.est)))

if (plot.target=="pdf") pdf(paste(filename,".pdf",sep=""))
if (plot.target=="png") {
  png(paste(filename,".png",sep=""),width=750,height=750 ,pointsize=18)
  par(lwd=3)
}
if (plot.target=="bitmap") bitmap(paste(filename,".bmp",sep=""),width=7,height=7,units="in",pointsize=15,res=300) #,cex=1.0,cex.axis=1.3,cex.lab=1.3,cex.main=2.0)

plot(years[ind],data1.tot$mean.est[ind],type="n",ylim=ylim,ylab=ylab,xlab="Year",lwd=lwd)
lines(years[ind],data1.tot$mean.est[ind],lty=1,col="blue",lwd=lwd)
lines(years[ind],data1.tot$ucl.est[ind],lty=2,col="blue",lwd=lwd)
lines(years[ind],data1.tot$lcl.est[ind],lty=2,col="blue",lwd=lwd)
lines(years[ind],data2.tot$mean.est[ind],lty=1,col="red",lwd=lwd)
lines(years[ind],data2.tot$ucl.est[ind],lty=2,col="red",lwd=lwd)
lines(years[ind],data2.tot$lcl.est[ind],lty=2,col="red",lwd=lwd)
if(plot.indep.est){
  points(indep.est.yr,indep.est,lwd=lwd)
  lines(rep(indep.est.yr,2),indep.cl,lwd=lwd)
}

dev.off()

#par(tmp.par)